

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)

Generated during DND operations.
-}

module GI.Gdk.Structs.EventDND
    ( 

-- * Exported types
    EventDND(..)                            ,
    newZeroEventDND                         ,
    noEventDND                              ,


 -- * Properties
-- ** Context
    eventDNDReadContext                     ,


-- ** SendEvent
    eventDNDReadSendEvent                   ,


-- ** Time
    eventDNDReadTime                        ,


-- ** Type
    eventDNDReadType                        ,


-- ** Window
    eventDNDReadWindow                      ,


-- ** XRoot
    eventDNDReadXRoot                       ,


-- ** YRoot
    eventDNDReadYRoot                       ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gdk.Types
import GI.Gdk.Callbacks

newtype EventDND = EventDND (ForeignPtr EventDND)
-- | Construct a `EventDND` struct initialized to zero.
newZeroEventDND :: MonadIO m => m EventDND
newZeroEventDND = liftIO $ callocBytes 40 >>= wrapPtr EventDND

noEventDND :: Maybe EventDND
noEventDND = Nothing

eventDNDReadType :: EventDND -> IO EventType
eventDNDReadType s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 0) :: IO CUInt
    let val' = (toEnum . fromIntegral) val
    return val'

eventDNDReadWindow :: EventDND -> IO Window
eventDNDReadWindow s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 8) :: IO (Ptr Window)
    val' <- (newObject Window) val
    return val'

eventDNDReadSendEvent :: EventDND -> IO Int8
eventDNDReadSendEvent s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 16) :: IO Int8
    return val

eventDNDReadContext :: EventDND -> IO DragContext
eventDNDReadContext s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 24) :: IO (Ptr DragContext)
    val' <- (newObject DragContext) val
    return val'

eventDNDReadTime :: EventDND -> IO Word32
eventDNDReadTime s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 32) :: IO Word32
    return val

eventDNDReadXRoot :: EventDND -> IO Int16
eventDNDReadXRoot s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 36) :: IO Int16
    return val

eventDNDReadYRoot :: EventDND -> IO Int16
eventDNDReadYRoot s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 38) :: IO Int16
    return val

type family ResolveEventDNDMethod (t :: Symbol) (o :: *) :: * where
    ResolveEventDNDMethod l o = MethodResolutionFailed l o

instance (info ~ ResolveEventDNDMethod t EventDND, MethodInfo info EventDND p) => IsLabelProxy t (EventDND -> p) where
    fromLabelProxy _ = overloadedMethod (MethodProxy :: MethodProxy info)

#if MIN_VERSION_base(4,9,0)
instance (info ~ ResolveEventDNDMethod t EventDND, MethodInfo info EventDND p) => IsLabel t (EventDND -> p) where
    fromLabel _ = overloadedMethod (MethodProxy :: MethodProxy info)
#endif


