

{- |
Copyright  : Will Thompson, Iñaki García Etxebarria and Jonas Platte
License    : LGPL-2.1
Maintainer : Iñaki García Etxebarria (garetxe@gmail.com)

Generated when a setting is modified.
-}

module GI.Gdk.Structs.EventSetting
    ( 

-- * Exported types
    EventSetting(..)                        ,
    newZeroEventSetting                     ,
    noEventSetting                          ,


 -- * Properties
-- ** Action
    eventSettingReadAction                  ,


-- ** Name
    eventSettingReadName                    ,


-- ** SendEvent
    eventSettingReadSendEvent               ,


-- ** Type
    eventSettingReadType                    ,


-- ** Window
    eventSettingReadWindow                  ,




    ) where

import Prelude ()
import Data.GI.Base.ShortPrelude

import qualified Data.Text as T
import qualified Data.ByteString.Char8 as B
import qualified Data.Map as Map

import GI.Gdk.Types
import GI.Gdk.Callbacks

newtype EventSetting = EventSetting (ForeignPtr EventSetting)
-- | Construct a `EventSetting` struct initialized to zero.
newZeroEventSetting :: MonadIO m => m EventSetting
newZeroEventSetting = liftIO $ callocBytes 32 >>= wrapPtr EventSetting

noEventSetting :: Maybe EventSetting
noEventSetting = Nothing

eventSettingReadType :: EventSetting -> IO EventType
eventSettingReadType s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 0) :: IO CUInt
    let val' = (toEnum . fromIntegral) val
    return val'

eventSettingReadWindow :: EventSetting -> IO Window
eventSettingReadWindow s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 8) :: IO (Ptr Window)
    val' <- (newObject Window) val
    return val'

eventSettingReadSendEvent :: EventSetting -> IO Int8
eventSettingReadSendEvent s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 16) :: IO Int8
    return val

eventSettingReadAction :: EventSetting -> IO SettingAction
eventSettingReadAction s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 20) :: IO CUInt
    let val' = (toEnum . fromIntegral) val
    return val'

eventSettingReadName :: EventSetting -> IO T.Text
eventSettingReadName s = withManagedPtr s $ \ptr -> do
    val <- peek (ptr `plusPtr` 24) :: IO CString
    val' <- cstringToText val
    return val'

type family ResolveEventSettingMethod (t :: Symbol) (o :: *) :: * where
    ResolveEventSettingMethod l o = MethodResolutionFailed l o

instance (info ~ ResolveEventSettingMethod t EventSetting, MethodInfo info EventSetting p) => IsLabelProxy t (EventSetting -> p) where
    fromLabelProxy _ = overloadedMethod (MethodProxy :: MethodProxy info)

#if MIN_VERSION_base(4,9,0)
instance (info ~ ResolveEventSettingMethod t EventSetting, MethodInfo info EventSetting p) => IsLabel t (EventSetting -> p) where
    fromLabel _ = overloadedMethod (MethodProxy :: MethodProxy info)
#endif


